#ifndef SIMPLESTRING_H
#define SIMPLESTRING_H

#include <iostream>

class SimpleString {
public:
    // Default constructor - should create an empty string
    SimpleString();

    // Constructor from C-string - should copy contents of given C-string
    SimpleString(const char* text);

    // Copy constructor - should create a deep copy of another SimpleString
    SimpleString(const SimpleString& other);

    // Assignment operator - should release old memory and copy from another SimpleString
    SimpleString& operator=(const SimpleString& other);

    // Equality operator - should compare contents of two SimpleStrings
    bool operator==(const SimpleString& other) const;

    // Destructor - should release dynamically allocated memory
    ~SimpleString();

    // Return the length of the string
    int Length() const;

    // Print the string to standard output
    void Print() const;

    // Overload << operator to allow printing via ostream. 'Friend' means it can access private members.
    friend std::ostream& operator<<(std::ostream& os, const SimpleString& str);

private:
    char* data;
};

#endif // SIMPLESTRING_H
